/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_clusterapi/clusterapi/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeClusterClasses implements ClusterClassInterface
type FakeClusterClasses struct {
	Fake *FakeClusterV1beta1
	ns   string
}

var clusterclassesResource = schema.GroupVersionResource{Group: "cluster.x-k8s.io", Version: "v1beta1", Resource: "clusterclasses"}

var clusterclassesKind = schema.GroupVersionKind{Group: "cluster.x-k8s.io", Version: "v1beta1", Kind: "ClusterClass"}

// Get takes name of the clusterClass, and returns the corresponding clusterClass object, and an error if there is any.
func (c *FakeClusterClasses) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ClusterClass, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(clusterclassesResource, c.ns, name), &v1beta1.ClusterClass{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ClusterClass), err
}

// List takes label and field selectors, and returns the list of ClusterClasses that match those selectors.
func (c *FakeClusterClasses) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ClusterClassList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(clusterclassesResource, clusterclassesKind, c.ns, opts), &v1beta1.ClusterClassList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ClusterClassList{ListMeta: obj.(*v1beta1.ClusterClassList).ListMeta}
	for _, item := range obj.(*v1beta1.ClusterClassList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested clusterClasses.
func (c *FakeClusterClasses) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(clusterclassesResource, c.ns, opts))

}

// Create takes the representation of a clusterClass and creates it.  Returns the server's representation of the clusterClass, and an error, if there is any.
func (c *FakeClusterClasses) Create(ctx context.Context, clusterClass *v1beta1.ClusterClass, opts v1.CreateOptions) (result *v1beta1.ClusterClass, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(clusterclassesResource, c.ns, clusterClass), &v1beta1.ClusterClass{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ClusterClass), err
}

// Update takes the representation of a clusterClass and updates it. Returns the server's representation of the clusterClass, and an error, if there is any.
func (c *FakeClusterClasses) Update(ctx context.Context, clusterClass *v1beta1.ClusterClass, opts v1.UpdateOptions) (result *v1beta1.ClusterClass, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(clusterclassesResource, c.ns, clusterClass), &v1beta1.ClusterClass{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ClusterClass), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeClusterClasses) UpdateStatus(ctx context.Context, clusterClass *v1beta1.ClusterClass, opts v1.UpdateOptions) (*v1beta1.ClusterClass, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(clusterclassesResource, "status", c.ns, clusterClass), &v1beta1.ClusterClass{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ClusterClass), err
}

// Delete takes name of the clusterClass and deletes it. Returns an error if one occurs.
func (c *FakeClusterClasses) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(clusterclassesResource, c.ns, name, opts), &v1beta1.ClusterClass{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeClusterClasses) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(clusterclassesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ClusterClassList{})
	return err
}

// Patch applies the patch and returns the patched clusterClass.
func (c *FakeClusterClasses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ClusterClass, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(clusterclassesResource, c.ns, name, pt, data, subresources...), &v1beta1.ClusterClass{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ClusterClass), err
}
